<template>
  <v-list-item
      :x-data="person.nick"
      @click="selectUser(index)"
      :class="{
          'person-item': true,
          selected: selectedPerson === persons[index],
      }"
      link
  >
      <v-list-item-icon>
          <v-img
              lazy-src="https://picsum.photos/id/11/10/6"
              :class="{ 'logged-out': !person.loggedIn }"
              max-height="120"
              max-width="60"
              :src="photo"
          ></v-img>
      </v-list-item-icon>
      <v-list-item-content>
          <v-list-item-title style="display: flex; flex-direction: row;">
              {{ person?.nick }}
              <v-tooltip v-if="person.blocked" bottom>
                  <template v-slot:activator="{ on, attrs }">
                      <span v-bind="attrs" v-on="on">
                          <v-icon color="error">mdi-cancel</v-icon>
                      </span>
                  </template>
                  <span> Użytkownik {{ person?.nick }} Cię zablokował </span>
              </v-tooltip>

              <v-tooltip v-if="person.blocks" bottom>
                  <template v-slot:activator="{ on, attrs }">
                      <span v-bind="attrs" v-on="on">
                          <v-icon color="error">mdi-cancel</v-icon>
                      </span>
                  </template>
                  <span>
                      Zablokowałeś użytkownika {{ person?.nick }}.<br />
                      Kliknij prawym przyciskiem myszy, by go odblokować.
                  </span>
              </v-tooltip>
              <v-badge
                  style="position: relative; left: 5px"
                  v-if="person.nrOfMessages > 0 && selectedPerson.nick !== person.nick"
                  color="info"
                  :content="person.nrOfMessages"
              >
              </v-badge>
          </v-list-item-title>
      </v-list-item-content>
  </v-list-item>
</template>

<script>
export default {
  name: 'PersonInList',
  props: {
      selectUser: {
          type: Function,
          required: true,
      },
      person: {
          type: Object,
          required: true,
      },
      persons: {
          type: Array,
          required: true,
      },
      index: {
          type: Number,
          required: true,
      },
      selectedPerson: {
          type: Object,
          required: true,
      },
  },
  data() {
      return {
          photo: null,
      };
  },
  mounted() {
      this.$axios
          .post(this.$config.serverUrl + '/user/get-friend-image', {
              uuid: this.$store.state.user.uuid,
              friendNick: this.person.nick,
          })
          .then(({ data }) => {
              for (let i = 0, max = data.length; i < max; i++) {
                  if (data[i].fromNick === this.person.nick) {
                      this.photo = JSON.parse(data[i].fromPhotos).profile;
                      return;
                  }
                  if (data[i].toNick === this.person.nick) {
                      this.photo = JSON.parse(data[i].toPhotos).profile;
                      return;
                  }
              }
              console.log(data);
          })
          .catch((e) => {
              console.error(e);
          });

      this.$bus.$on('block-user', () => {
          this.$forceUpdate();
      });

      this.$bus.$on('un-block-user', () => {
          this.$forceUpdate();
      });

      this.$bus.$on('refresh-person-in-list', () => {
          this.$forceUpdate();
      });
  },
};
</script>

<style scoped lang="scss">
.v-list-item--dense .v-list-item__icon, .v-list--dense .v-list-item .v-list-item__icon {
  height: 69px;
}

.logged-out {
  filter: grayscale(80%);
}
</style>
